︠d8afed30-50a7-4fe7-aebf-360269e982cds︠
go??
︡e4e79be2-e48b-4bab-afa8-9066ce77c2fd︡{"code":{"filename":null,"lineno":-1,"mode":"python","source":"   File: /projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\n   Source:\n   def go(s):\n    \"\"\"\n    Run a go program.  For example,\n\n        %go\n        func main() { fmt.Println(\"Hello World\") }\n\n    You can set the whole worksheet to be in go mode by typing\n\n        %default_mode go\n\n    NOTES:\n\n    - The official Go tutorial as a long Sage Worksheet is available here:\n\n        https://github.com/sagemath/cloud-examples/tree/master/go\n\n    - There is no relation between one cell and the next.  Each is a separate\n      self-contained go program, which gets compiled and run, with the only\n      side effects being changes to the filesystem.  The program itself is\n      stored in a random file that is deleted after it is run.\n\n    - The %go command automatically adds 'package main' and 'import \"fmt\"'\n      (if fmt. is used) to the top of the program, since the assumption\n      is that you're using %go interactively.\n    \"\"\"\n    import uuid\n    name = str(uuid.uuid4())\n    if 'fmt.' in s and '\"fmt\"' not in s and \"'fmt'\" not in s:\n        s = 'import \"fmt\"\\n' + s\n    if 'package main' not in s:\n        s = 'package main\\n' + s\n    try:\n        open(name +'.go','w').write(s.encode(\"UTF-8\"))\n        (child_stdin, child_stdout, child_stderr) = os.popen3('go build %s.go'%name)\n        err = child_stderr.read()\n        sys.stdout.write(child_stdout.read())\n        sys.stderr.write(err)\n        sys.stdout.flush()\n        sys.stderr.flush()\n        if not os.path.exists(name): # failed to produce executable\n            return\n        (child_stdin, child_stdout, child_stderr) = os.popen3(\"./\" + name)\n        sys.stdout.write(child_stdout.read())\n        sys.stderr.write(child_stderr.read())\n        sys.stdout.flush()\n        sys.stderr.flush()\n    finally:\n        try:\n            os.unlink(name+'.go')\n        except:\n            pass\n        try:\n            os.unlink(name)\n        except:\n            pass\n"}}︡{"done":true}︡
︠2b8c2b5d-6533-463e-b4cc-fc1c550de49d︠
